<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Order Detail</title>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <p class="h3 text-left mt-5 "> Order Detail !! </p>
    <div class="form-group col-12">
      <!-- <hr class="mt-5 mb-5" /> -->
    </div>

    <div class="form-group">
      <label>Order Code(mã đơn hàng):</label>
      <input class="form-control" id="input-order-code" placeholder="...">
    </div>
    <div class="form-group">
      <label>Có Combo:</label>
      <select class="form-control" id="select-combo">
        <option> Chọn cỡ Combo (Combo size)</option>
        <option value="S (small)"> Nhỏ</option>
        <option value="M (medium)"> Vừa</option>
        <option value="L (large)"> Lớn</option>
      </select>
    </div>
    <div class="form-group">
      <label>Đường kính Pizza</label>
      <input class="form-control" id="input-duong-kinh" placeholder="...">
    </div>
    <div class="form-group">
      <label>Sườn nướng(miếng)</label>
      <input class="form-control" id="input-suon-nuong">
    </div>
    <div class="form-group">
      <label>Đồ uống</label>
      <select class="form-control" id="select-drink">
        <option value="#">Chọn nước uống</option>
      </select>
    </div>
    <div class="form-group">
      <label>Số lượng nước uống</label>
      <input class="form-control" id="input-number-drink">
    </div>
    <div class="form-group">
      <label>Voucher ID</label>
      <input class="form-control" id="input-vourcher-id">
    </div>
    <div class="form-group">
      <label>Loại pizza</label>
      <input class="form-control" id="input-pizza-type">
    </div>
    <div class="form-group">
      <label>Salad</label>
      <input class="form-control" id="input-salad">
    </div>
    <div class="form-group">
      <label>Thành tiền</label>
      <input class="form-control" id="input-price">
    </div>
    <div class="form-group">
      <label>Giảm giá</label>
      <input class="form-control" id="input-giam-gia">
    </div>
    <div class="form-group">
      <label>Họ và tên</label>
      <input class="form-control" id="input-ho-ten">
    </div>
    <div class="form-group">
      <label>Email</label>
      <input class="form-control" id="input-email">
    </div>
    <div class="form-group">
      <label>Số điện thoại</label>
      <input class="form-control" id="input-phone-number">
    </div>
    <div class="form-group">
      <label>Địa chỉ</label>
      <input class="form-control" id="input-dia-chi">
    </div>
    <div class="form-group">
      <label>Lời nhắn</label>
      <input class="form-control" id="input-tin-nhan">
    </div>
    <div class="form-group">
      <label> Trạng thái đơn hàng</label>
      <input class="form-control" id="input-trang-thai">
    </div>
    <div class="form-group">
      <label>Ngày tạo đơn</label>
      <input class="form-control" id="input-ngay-tao-don">
    </div>
    <div class="form-group">
      <label>Ngày cập nhật</label>
      <input class="form-control" id="input-ngay-cap-nhat">
    </div>
    <div class="form-group">
      <button class="btn btn-success" onclick="onBtnConfirmClick()">Confirm</button>
      <button class="btn btn-info" onclick="onBtnCancleClick()">Cancle</button>
    </div>
  </div>
</body>
<script>
  "use strict";
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
  const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders/";
  var gId = "";
  var gOrderCode = "";

  function onPageLoading() {
    loadDataDrinkList();
    getDataOrderCreated();
  }

  function onBtnConfirmClick() {
    console.log("ID : " + gId);
    updateOrderDetail('confirmed');
  }

  function onBtnCancleClick() {
    console.log("ID : " + gId);
    updateOrderDetail('cancle');
  }

  function updateOrderDetail(paramAction) {
    if (paramAction == 'confirmed') {
      var vObjectRequest = {
        trangThai: "confirmed"
      }
    } else if (paramAction == 'cancle') {
      var vObjectRequest = {
        trangThai: "cancle"
      }
    }


    var vXmlHttp = new XMLHttpRequest();
    vXmlHttp.open('PUT', gBASE_URL + '/' + gId, true);
    vXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
    vXmlHttp.send(JSON.stringify(vObjectRequest));
    vXmlHttp.onreadystatechange = function () {
      if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
        var vUpdateOrder = vXmlHttp.responseText;
        console.log(vUpdateOrder);
        alert("Cập nhật trạng thái đơn hàng thành công");
        window.location.href = 'order-List.html';
      }
    };
  }

  function getDataOrderCreated() {
    var vUrlString = window.location.href;
    var vUrl = new URL(vUrlString);
    gOrderCode = vUrl.searchParams.get('orderCode');
    gId = vUrl.searchParams.get('id');
    console.log('ID: ' + gId + "- Order Code: " + gOrderCode);
    var vXmlHttp = new XMLHttpRequest();
    vXmlHttp.open("GET", gBASE_URL + gOrderCode, true);
    vXmlHttp.send();
    vXmlHttp.onreadystatechange = function () {
      if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
        console.log(vXmlHttp.responseText);
        showDataOrder(vXmlHttp.responseText);
      }
    }
  }

  function showDataOrder(paramXmlHttp) {
    var vOderObj = JSON.parse(paramXmlHttp);
    // console.log(vOderObj);
    var vCreatedDay = new Date(vOderObj.ngayTao);
    var vUpdatedDay = new Date(vOderObj.ngayCapNhat);


    var vInpOrderCode = document.getElementById("input-order-code");
    var vSelectCombo = document.getElementById("select-combo");
    var vInpDuongKinh = document.getElementById("input-duong-kinh");
    var vInpSuonNuong = document.getElementById("input-suon-nuong");
    var vSelectDrink = document.getElementById("select-drink");
    var vInpNumberDrink = document.getElementById("input-number-drink");
    var vInpVourcherId = document.getElementById("input-vourcher-id");
    var vInpPizzaType = document.getElementById("input-pizza-type");
    var vInpSalad = document.getElementById("input-salad");
    var vInpPrice = document.getElementById("input-price");
    var vInpGiamgia = document.getElementById("input-giam-gia");
    var vInpHoten = document.getElementById("input-ho-ten");
    var vInpEmail = document.getElementById("input-email");
    var vInpPhoneNumber = document.getElementById("input-phone-number");
    var vInpDiaChi = document.getElementById("input-dia-chi");
    var vInpTinNhan = document.getElementById("input-tin-nhan");
    var vInpTrangThai = document.getElementById("input-trang-thai");
    var vInpNgayTaoDon = document.getElementById("input-ngay-tao-don");
    var vInpNgayCapNhat = document.getElementById("input-ngay-cap-nhat");

    vInpOrderCode.value = vOderObj.orderCode;
    vSelectCombo.value = vOderObj.kichCo;
    vInpDuongKinh.value = vOderObj.duongKinh;
    vInpSuonNuong.value = vOderObj.suon;
    vSelectDrink.value = vOderObj.idLoaiNuocUong;
    vInpNumberDrink.value = vOderObj.soLuongNuoc;
    vInpVourcherId.value = vOderObj.idVourcher;
    vInpPizzaType.value = vOderObj.loaiPizza;
    vInpSalad.value = vOderObj.salad;
    vInpPrice.value = vOderObj.thanhTien;
    vInpGiamgia.value = vOderObj.giamGia;
    vInpHoten.value = vOderObj.hoTen;
    vInpEmail.value = vOderObj.email;
    vInpPhoneNumber.value = vOderObj.soDienThoai;
    vInpDiaChi.value = vOderObj.diaChi;
    vInpTinNhan.value = vOderObj.loiNhan;
    vInpTrangThai.value = vOderObj.trangThai;
    vInpNgayTaoDon.value = vCreatedDay.toString();
    vInpNgayCapNhat.value = vUpdatedDay.toString();
  }

  function loadDataDrinkList() {
    var vXhttp = new XMLHttpRequest();
    vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
    vXhttp.send();
    vXhttp.onreadystatechange = function () {
      if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
        // console.log(vXhttp.responseText); // ghi response text ra console.log
        handleLoadDataToSelectDrink(vXhttp);
      }
    };
  }

  // handle data load to select drink
  function handleLoadDataToSelectDrink(paramXhttp) {
    var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
    // console.log(vArrayDrinkList);
    // console.log("array drink list = " + vArrayDrinkList.length);
    //load data to drink select
    var vElementSelectDrink = document.getElementById("select-drink");
    // console.log(vElementSelectDrink);
    for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
      var vDrinkOptionElement = document.createElement("option");
      vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
      vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
      vElementSelectDrink.appendChild(vDrinkOptionElement);
    }
  }


</script>

</html>